package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.items.items;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class breachingArrow extends baseArrow{
    public breachingArrow(EntityType<breachingArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel);
    }

    public breachingArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_BREACHING.get());
    }

    @Override
    protected void onHit(@NotNull HitResult pResult) {
        for (Entity entity : getEntities()) {
            onHitEntity(new EntityHitResult(entity));
        }
        super.onHit(pResult);
    }

    protected List<Entity> getEntities() {
        List<Entity> ret_list = new ArrayList<>();
        Vec3 corner1 = position().subtract(4, 4, 4);
        Vec3 corner2 = position().add(4, 4, 4);
        AABB boundingBox = new AABB(corner1, corner2);
        for (Entity entity : level().getEntitiesOfClass(LivingEntity.class, boundingBox)) {
            if (entity.getBoundingBox().intersects(position(), position().add(getDeltaMovement().normalize().scale(10)))) {
                ret_list.add(entity);
            }
        }
        return ret_list;
    }

    @NotNull
    protected ItemStack getPickupItem() {
        return new ItemStack(items.ARROW_BREACHING.get());
    }
}
