package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.items.items;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class enderArrow extends baseArrow {
    public enderArrow(EntityType<enderArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel);
    }

    public enderArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_ENDER.get());
    }

    @Override
    protected void onHitEntity(@NotNull EntityHitResult pTarget) {
        super.onHitEntity(pTarget);
        Entity target = pTarget.getEntity();
        target.addDeltaMovement(getDeltaMovement().multiply(1.5, 0.2, 1.5));
    }

    @NotNull
    protected ItemStack getPickupItem() {
        return new ItemStack(items.ARROW_ENDER.get());
    }

    @Override
    protected void onHit(@NotNull HitResult pResult) {
        super.onHit(pResult);
        if (getOwner() != null) {
            Vec3 pos = pResult.getLocation();
            level().getPlayerByUUID(getOwner().getUUID()).teleportTo(pos.x, pos.y, pos.z);
        }
    }

    @Override
    public void spawnParticles() {
        for (int i = 1; i <= ConfigClient.calcPCount(5); i++) {
            Vec3 pos = createParticlePos(1f);
            level().addParticle(ParticleTypes.ELECTRIC_SPARK, pos.x, pos.y, pos.z, 0, 0, 0);
        }
    }
}
